#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "param.h"


#define ParamSize 100


static char  ParamType[ParamSize];
static char  Param   [ParamSize][33];

int NumParams;
int Base;


// Initialize Parameter Table to Null
void ClearParams()
{
	int i;

	for (i = 0; i < ParamSize; i++)
	{
		memset(Param[i], 0, 33);
		ParamType[i] = ' ';
	}
	NumParams = 0;
}


// Find the Parameter Number
int ParamNumber(char* N)
{
	int i;

	for (i = 0; i < ParamSize; i++)
	{
		if (strcmp(N, Param[i]) == 0)
		{
			return(i);
		}
	}
	printf ("ParamNumber: Not found\n");
	exit(-1);
}




// See if an identifier is a parameter
int IsParam(char* Symbol)
{
	int i;

	for (i = 0; i < NumParams; i++)
	{
		if (strcmp(Symbol, Param[i]) == 0)
		{
			return(1);
		}
	}
	return (0); 
}

// Add a New Parameter to Table
void AddParam(char* Name)
{
	if (IsParam(Name))
	{
		printf ("Duplicate parameter name %s\n", Name);
		exit(-1);
	}
	strcpy (Param[NumParams], Name);
	NumParams++;
}

