#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "param.h"

#define STSize 100

static int NEntry = 0;

static char  SType[STSize];
static char  ST   [STSize][33];


// Look for Symbol in Table
int InTable(char* Symbol)
{
	int i;

	for (i = 0; i < NEntry; i++)
	{
		if (strcmp(Symbol,ST[i]) == 0)
		{
			return(1);
		}
	}
	return (0); 
}

// Check the Symbol Table for a Duplicate Identifier
// Report an error if identifier is already in table
void CheckDup(char* Symbol)
{
	if (InTable(Symbol))
	{
		printf ("Error: Duplicate symbol: %s\n", Symbol);
		exit(-1);
	}
}

// Add a New Entry to Symbol Table
void AddEntry(char* Symbol, char type)
{
	CheckDup(Symbol);
	if (NEntry == STSize)
	{
		printf ("Symbol Table Full\n");
		exit (-1);
	}
	strcpy(ST[NEntry], Symbol);
	SType[NEntry] = type;
	NEntry++;
}

// Return the type of a symbol
char TypeOf(char* Symbol)
{
	int i;

	if (IsParam(Symbol))
	{
		return('f');
	}

	for (i = 0; i < NEntry; i++)
	{
		if (strcmp(Symbol,ST[i]) == 0)
		{
			return(SType[i]);
		}
	}
	return (' '); 
}




